(function() {
  var out, url;
  url = require('url');
  out = (require('styout')).instance('jsonp-filter');
  out.verbosity = out.WARN_VERBOSITY;
  exports.setupJSONP = function() {
    var checkJSON;
    checkJSON = function(requrl) {
      var uri;
      uri = url.parse(requrl);
      return /json=true/i.test(uri.query != null ? uri.query : '');
    };
    return function(req, res, next) {
      var end, isJSON, json, write;
      isJSON = checkJSON(req.url);
      json = '';
      if (isJSON) {
        write = res.write;
        res.write = function(chunk, encoding) {
          res.write = write;
          out.debug('res.write json');
          return json += chunk.toString(encoding != null ? encoding : 'utf8');
        };
        end = res.end;
        res.end = function(data, encoding) {
          res.end = end;
          out.debug('res.end json');
          res.removeHeader('content-length');
          return res.json(json);
        };
      }
      return next();
    };
  };
}).call(this);
